__doc__ = """ZMailIn initialisation module."""

# $Id: __init__.py,v 1.6 2002/02/05 15:22:16 andyd Exp $

__version__='$Revision: 1.6 $'[11:-2]  

from ZMailIn import ZMailIn, manage_addZMailIn, manage_addZMailInForm
from ZMailMessage import ZMailMessage, manage_addZMailMessage, manage_addZMailMessageForm
from Products.ZCatalog import ZCatalog
from Products.PluginIndexes.FieldIndex.FieldIndex import FieldIndex

def initialize(context): 
    """Initialise the ZMailIn product."""
    
    # Get the product context app
    app = context._ProductContext__app
    proddir = app #.Control_Panel.Products.ZMailIn # Change this to place Global catalog somewhere different
            
    #This bit adds a Catalog to the ZMailIn Product folder of zope for cataloging instances of ZMailIn
    if hasattr(proddir, 'GlobalZMailInCatalog'):
            globalcat = getattr(proddir, 'GlobalZMailInCatalog', None) # get the catalog
    else:
            oglobalcat = ZCatalog.ZCatalog('GlobalZMailInCatalog','Global ZMailIn Catalog')
            proddir._setObject('GlobalZMailInCatalog', oglobalcat)
            get_transaction().note('Added GlobalZMailInCatalog')
            get_transaction().commit()
            globalcat = getattr(proddir, 'GlobalZMailInCatalog', None)
            globalcat._catalog.addColumn('absolute_url') # Add absolute_url to the meta data
            globalcat._catalog.addIndex('email_address',FieldIndex('email_address')) # Add email_address to the index of the catalog

    # Register the products
    context.registerClass(
            
        ZMailIn,                           # Which is the addable bit? 
            
        constructors = (                   # The first of these is called 
            manage_addZMailInForm,         # when someone adds the product; 
            manage_addZMailIn),            # the second is named here so we 
                                           # can give people permission to 
                                           # call it. 
                                             
        icon = 'www/mailin.png'
        )

    context.registerClass(
            
        ZMailMessage,                                # Which is the addable bit? 
            
        constructors = (                             # The first of these is called 
            manage_addZMailMessageForm,              # when someone adds the product; 
            manage_addZMailMessage),                 # the second is named here so we 
                                                     # can give people permission to 
                                                     # call it. 
                                             
        icon = 'www/mail.png'                            
            
        )
    
    context.registerHelp()
    context.registerHelpTitle('ZMailIn Help')
       

def getZMailInClientLocation(self):
        """Uses the GlobalZMailInCatalog to get the location of the ZMailIn client for this current email address"""

        REQUEST = self.REQUEST
        
        # Get the GlobalZMailInCatalog from the Product folder
        catalog = self.restrictedTraverse("/GlobalZMailInCatalog",None) #Control_Panel/Products/ZMailIn/GlobalZMailInCatalog",None)
        
        if catalog:
                results = catalog.searchResults(REQUEST=REQUEST,email_address=REQUEST['email_address'])
                if results:
                        return "%s"%results[0].absolute_url
                else:
                        return 'Not Found'
        else:
                return 'FAIL: Unable to find GlobalZMailInCatalog'
            
# make the getZMailInClientLocation method accessible
methods={ 'getZMailInClientLocation': getZMailInClientLocation}  